package cn.com.infosec.util.base64;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;

public abstract class MyCharacterEncoder {
   protected PrintStream pStream;

   protected abstract int bytesPerAtom();

   protected abstract int bytesPerLine();

   protected void encodeBufferPrefix(OutputStream outputstream) {
      MyCharacterEncoder var10000 = this;
      PrintStream var2;
      var2 = new PrintStream.<init>(outputstream);
      var10000.pStream = var2;
   }

   protected void encodeBufferSuffix(OutputStream outputstream) {
   }

   protected void encodeLinePrefix(OutputStream outputstream, int i) {
   }

   protected void encodeLineSuffix(OutputStream outputstream) {
   }

   protected abstract void encodeAtom(OutputStream var1, byte[] var2, int var3, int var4);

   protected int readFully(InputStream inputstream, byte[] abyte0) {
      for(int var4 = 0; var4 < abyte0.length; ++var4) {
         int var3;
         if ((var3 = inputstream.read()) == -1) {
            return var4;
         }

         abyte0[var4] = (byte)var3;
      }

      return abyte0.length;
   }

   public void encode(InputStream inputstream, OutputStream outputstream) {
      byte[] var3 = new byte[this.bytesPerLine()];
      this.encodeBufferPrefix(outputstream);

      int var4;
      while((var4 = this.readFully(inputstream, var3)) != 0) {
         this.encodeLinePrefix(outputstream, var4);

         for(int var5 = 0; var5 < var4; var5 += this.bytesPerAtom()) {
            int var6;
            if (var5 + this.bytesPerAtom() <= var4) {
               var6 = this.bytesPerAtom();
               this.encodeAtom(outputstream, var3, var5, var6);
            } else {
               var6 = var4 - var5;
               this.encodeAtom(outputstream, var3, var5, var6);
            }
         }

         if (var4 < this.bytesPerLine()) {
            break;
         }

         this.encodeLineSuffix(outputstream);
      }

      this.encodeBufferSuffix(outputstream);
   }

   public void encode(byte[] abyte0, OutputStream outputstream) {
      MyCharacterEncoder var10000 = this;
      ByteArrayInputStream var3;
      var3 = new ByteArrayInputStream.<init>(abyte0);
      var10000.encode((InputStream)var3, outputstream);
   }

   public String encode(byte[] abyte0) {
      ByteArrayOutputStream var2;
      ByteArrayOutputStream var10000 = var2 = new ByteArrayOutputStream;
      MyCharacterEncoder var10001 = this;
      var2.<init>();
      ByteArrayOutputStream var10003 = var2;
      ByteArrayInputStream var10002 = new ByteArrayInputStream(abyte0);

      try {
         var10001.encode((InputStream)var10002, var10003);
         return var10000.toString("8859_1");
      } catch (Exception var3) {
         throw new Error("ChracterEncoder::encodeBuffer internal error");
      }
   }

   public void encodeBuffer(InputStream inputstream, OutputStream outputstream) {
      byte[] var3 = new byte[this.bytesPerLine()];
      this.encodeBufferPrefix(outputstream);

      int var4;
      while((var4 = this.readFully(inputstream, var3)) != 0) {
         this.encodeLinePrefix(outputstream, var4);

         for(int var5 = 0; var5 < var4; var5 += this.bytesPerAtom()) {
            int var6;
            if (var5 + this.bytesPerAtom() <= var4) {
               var6 = this.bytesPerAtom();
               this.encodeAtom(outputstream, var3, var5, var6);
            } else {
               var6 = var4 - var5;
               this.encodeAtom(outputstream, var3, var5, var6);
            }
         }

         this.encodeLineSuffix(outputstream);
         if (var4 < this.bytesPerLine()) {
            break;
         }
      }

      this.encodeBufferSuffix(outputstream);
   }

   public void encodeBuffer(byte[] abyte0, OutputStream outputstream) {
      MyCharacterEncoder var10000 = this;
      ByteArrayInputStream var3;
      var3 = new ByteArrayInputStream.<init>(abyte0);
      var10000.encodeBuffer((InputStream)var3, outputstream);
   }

   public String encodeBuffer(byte[] abyte0) {
      MyCharacterEncoder var10000 = this;
      ByteArrayOutputStream var3;
      var3 = new ByteArrayOutputStream.<init>();
      ByteArrayOutputStream var10002 = var3;
      ByteArrayInputStream var10001 = new ByteArrayInputStream(abyte0);

      try {
         var10000.encodeBuffer((InputStream)var10001, var10002);
      } catch (Exception var2) {
         throw new Error("ChracterEncoder::encodeBuffer internal error");
      }

      return var3.toString();
   }
}
